#ifndef UNICODE
#define UNICODE
#endif 

#include "CEveOnlineAPI.hpp"
#include <string>
#include <windows.h>
#include <Wininet.h>
#include <iostream>
#include <fstream>
#include "API_URLs.hpp"
#pragma comment(lib, "wininet.lib")
#include <Windowsx.h>
#include "tinyxml2.h"
#include <vector>
#include <commctrl.h>
#pragma comment(lib, "comctl32.lib")


#define MENU_EXIT_BUTTON 1;
#define MENU_SETTINGS_BUTTON 2;

// Register the window class.
const wchar_t CLASS_NAME[] = L"TheChecker";
const wchar_t CLASS_NAME_CHILD[] = L"Child";


struct HandleStorage{
	std::vector<HWND> vHandlePtr;
	std::vector<std::wstring> vHandleName;
};

HandleStorage Test;



// function forward declaration

DWORD Error = 0;


LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WindowChildProc(HWND Childhwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


BOOL DrawMenu(HWND hwnd);





int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE, PWSTR pCmdLine, int nCmdShow)
{
	// Define a structure to hold some state information.
	InitCommonControls();
	WNDCLASS wc = {};

	wc.lpfnWndProc = WindowProc;
	wc.hInstance = hInstance;
	wc.lpszClassName = CLASS_NAME;
	RegisterClass(&wc);
	// Create the window.

	
	
	
	HWND hwnd = CreateWindowEx(
		0,                              // Optional window styles.
		CLASS_NAME,                     // Window class
		L"Learn to Program Windows",    // Window text
		WS_OVERLAPPEDWINDOW,            // Window style
		CW_USEDEFAULT,					// Size and position
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,							// Parent window    
		NULL,							// Menu
		hInstance,						// Instance handle
		NULL							// Additional application data
		);

	if (hwnd == NULL)
	{
		return 0;
	}


	

	// Define a structure to hold some state information.


	WNDCLASS wcc = {};

	wcc.lpfnWndProc = WindowChildProc;
	wcc.hInstance = hInstance;
	wcc.lpszClassName = CLASS_NAME_CHILD;

	RegisterClass(&wcc);


	

	ShowWindow(hwnd, nCmdShow);
    MSG msg = { };
    while (GetMessage(&msg, NULL, 0, 0))   // Run the message loop.
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return 0;
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
    {
		case WM_CREATE:
		{
						  DrawMenu(hwnd);
						  return 0;
		}
		case WM_COMMAND:
		{
						   switch (wParam)
						   {
								case 1:
								{
										  PostQuitMessage(0);
										  return 0;
								}
								case 2:
								{  
										  int i = 0;
										  HWND Childhwnd = CreateWindow(
											  CLASS_NAME_CHILD,                     // Window class
											  L"API Key Manager",    // Window text
											  WS_CHILDWINDOW | WS_VISIBLE ,//| WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,          // Window style
											  100,				// Size and position
											  100,
											  800,
											  250,
											  hwnd,							// Parent window    
											  NULL,							// Menu
											  (HINSTANCE)GetWindowLongPtr(hwnd, GWL_HINSTANCE),						// Instance handle
											  NULL							// Additional application data
											  );
											  ShowWindow(Childhwnd, SW_SHOW);

								}
								case 3:
								{
								}
								case 4:
								{
								}
						   }
						   return 0;
		}
		case WM_DESTROY:
		{
			PostQuitMessage(0);
			return 0;
		}
		case WM_PAINT:
		{	
				PAINTSTRUCT ps;
				HDC hdc = BeginPaint(hwnd, &ps);
				FillRect(hdc, &ps.rcPaint, (HBRUSH) (COLOR_WINDOW));
				EndPaint(hwnd, &ps);
				return 0;
        }
		case WM_CLOSE:
		{
						 switch (wParam)
						 {
							 case 1:
							 {
								   PostQuitMessage(0);
								   return 0;
							 }
						 }
						 
						 
			if (MessageBox(hwnd, L"Really quit?", L"My application", MB_OKCANCEL) == IDOK)
			{
				DestroyWindow(hwnd);
			}// Else: User canceled. Do nothing.
			 return 0;
		}
    }
    return DefWindowProc(hwnd, uMsg, wParam, lParam);
}

BOOL DrawMenu(HWND hwnd){

	HMENU hMenuBar = CreateMenu();
	HMENU hFile = CreateMenu();
	HMENU hOptions = CreateMenu();
	AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR)hFile, L"Datei");
	AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR)hOptions, L"Optionen");
	AppendMenu(hFile, MF_STRING, 1, L"Schlieen");
	AppendMenu(hOptions, MF_STRING, 2, L"API Einstellungen");
	SetMenu(hwnd, hMenuBar);

	return 0;
}

LRESULT CALLBACK WindowChildProc(HWND Childhwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
	{


					  HWND hwndButton_OK = CreateWindow(
						  L"BUTTON",  // Predefined class; Unicode assumed 
						  L"OK",      // Button text 
						  WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,  // Styles 
						  10,         // x position 
						  10,         // y position 
						  100,        // Button width
						  30,        // Button height
						  Childhwnd,     // Parent window
						  (HMENU)8,       // edit control ID.
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);      // Pointer not needed.


					  HWND hwndButton_CANCEL = CreateWindow(
						  L"BUTTON",  // Predefined class; Unicode assumed 
						  L"CANCEL",      // Button text 
						  WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,  // Styles 
						  170,         // x position 
						  10,         // y position 
						  100,        // Button width
						  30,        // Button height
						  Childhwnd,     // Parent window
						  (HMENU)9,       // edit control ID.
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);      // Pointer not needed.


					  HWND hwndEdit_API_Key = CreateWindowEx(
						  WS_EX_CLIENTEDGE,
						  L"EDIT",   // predefined class 
						  NULL,         // no window title 
						  WS_CHILD | WS_VISIBLE,
						  260, 90, 200, 20,   // set size in WM_SIZE message 
						  Childhwnd,         // parent window 
						  (HMENU)10,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed 

					  HWND hwndEdit_VeriCode = CreateWindowEx(
						  WS_EX_CLIENTEDGE,
						  L"EDIT",   // predefined class 
						  NULL,         // no window title 
						  WS_CHILD | WS_VISIBLE,
						  260, 140, 200, 20,   // set size in WM_SIZE message 
						  Childhwnd,         // parent window 
						  (HMENU)11,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed

					  HWND hwndStatic_API_Key = CreateWindowEx(
						  NULL,
						  L"Static",   // predefined class 
						  L"API Key:",         // no window title 
						  WS_CHILD | WS_VISIBLE | ES_RIGHT,
						  50, 90, 200, 20,   // set size in WM_SIZE message 
						  Childhwnd,         // parent window 
						  (HMENU)12,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed
					  
					  HWND hwndStatic_VeriCode = CreateWindowEx(
						  NULL,
						  L"Static",   // predefined class 
						  L"Verification Code:",         // no window title 
						  WS_CHILD | WS_VISIBLE | ES_RIGHT,
						  50, 140, 200, 20,   // set size in WM_SIZE message 
						  Childhwnd,         // parent window 
						  (HMENU)13,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed
					  return 0;
	}
	case WM_COMMAND:
	{
					   switch (wParam)
					   {
					   case 8:
							{
								 
								 HWND Editbox = GetDlgItem(Childhwnd, 11);
								 std::wstring Focus;
								 Focus.append(std::to_wstring((int)GetFocus()));
								 Edit_SetText(Editbox, (LPWSTR)Focus.c_str());
								 UpdateWindow(Editbox);
								 return 0;
							}
					   case 9:
							{
								 SendMessage(Childhwnd, WM_CLOSE, NULL, NULL);
								 return 0;
							}
					   }
					   return 0;
	}
	case WM_DESTROY:
	{
					   return 0;
	}
	case WM_PAINT:
	{
					 PAINTSTRUCT ps;
					 HDC hdc = BeginPaint(Childhwnd, &ps);
					 FillRect(hdc, &ps.rcPaint, (HBRUSH)(COLOR_WINDOW));
					 EndPaint(Childhwnd, &ps);
					 return 0;
	}
	case WM_CLOSE:
	{
					 DestroyWindow(Childhwnd);
					 return 0;
	}
	}
	return DefWindowProc(Childhwnd, uMsg, wParam, lParam);
}

